#ifndef BI_IO_H
#define BI_IO_H

#include <stdio.h>

#define macroblock_quant            0x10
#define macroblock_motion_forward   0x08
#define macroblock_motion_backward  0x04
#define macroblock_pattern          0x02
#define macroblock_intra            0x01

class bi_io_class{
    FILE* in;
    unsigned int current_word; //ORDER byte1 byte2 byte3 byte4
    unsigned int temp_word;    //ORDER byte1 byte2 byte3 byte4
    int index;
    int *mb_increment_table;
    int *mb_type_p_table;
    int *mb_type_b_table;
    int *mb_pattern_table;
    int *mv_table;
    int *dc_l_table;
    int *dc_c_table;
    int *dct_1st_table; //for codeword which the first 8 bits are
                        // not all zeros.
    int *dct_2nd_table; //for codeword which the first 8 bits are
                        // all zeros.

public:
    int *flag; //if end-of-file return 1;
    FILE* err;

    bi_io_class(FILE* in);
    ~bi_io_class(void);
    
    unsigned int getn(int n); //get n bits form 'in'

    //unsigned int get8(void);
    //unsigned int get16(void);
    //unsigned int get32(void);

    unsigned int nextn(int n); //return the first n bits from 'in'
                               // without file-pointer moving
                               // used to compare the first n bits
    unsigned int next24(void);
    unsigned int next23(void);
    unsigned int next1(void);
    unsigned int next32(void);
    
    int eof(void); //return 1 if end-of-file

    int bytealigned(void); //return non-zero if the current position is 
                           //                   a byte boundary.

    void next_start_code(void);

    int get_mb_address_increment(void);
    int get_mb_type(int i);
    int get_mv(void);
    int get_cbp(void);
    int get_dc_size_l(void);
    int get_dc_size_c(void);
    void get_dct_first(int& run, int& level);
    void get_dct_next(int& run, int& level);

private:
    void build_mb_type_p_table(void);
    void build_mb_type_b_table(void);
    void build_dct_table(void);
    inline int  table_lookup(int table[], int max_len);
};

#endif